
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <bios.h>
#include <conio.h>
#include "..\..\dtc2.h"

FILE *fs,*fd;
char PP1[] = "----------------------------------\n";
char PP2[] = "nnnnnn  R  00  00000xxx  xxxx0000 \n";


int process(FILE *fd)
{
 ulong t,v;
 int i,j,bh,bl,ofs,dir,port;
 char s1[10],s2[10];
 double dt;

  v=0;
  strcpy(s1,"00000xxx");
  strcpy(s2,"xxxx0000");
  fseek(fd,0l,SEEK_SET);

  for (;;) {
    if ((v&0x7f)==0) {
      fread(&t,4,1,fs);
      dt = t/15.625;
      fprintf(fd,"-->TIME  %lf ms\n%s",dt,PP1);
     }
    bl=getc(fs); if (bl==EOF) break;
    bh=getc(fs); if (bh==EOF) break;
    port=(bh>>3)&3;		/* 3=0x100 */
    ofs=bh&7; dir=bh&0x40;
    sprintf(PP2,"%06ld  %c",v,(dir? 'R':'W'));
    switch(port) {
      case 1: case 2:
	switch(ofs&3) {
		case 0: sprintf(PP2+9,"  %02x\n",bl); break;
		case 1: for (j=0; j<5; j++) { s1[j]=(bl&0x80? '1':'0'); bl<<=1; }
			sprintf(PP2+9,"      %s\n",s1); break;
		case 2: for (j=0; j<4; j++) { s2[7-j]=(bl&1)+'0'; bl>>=1; }
			sprintf(PP2+9,"                %s\n",s2); break;
		case 3: sprintf(PP2+9,"3   %02x\n",bl); break;
	}
	break;
      case 3:
	sprintf(PP2+9,"%d   %02x\t(0x10%d)\n",ofs,bl,ofs);
	break;
    }
    fprintf(fd,"%s",PP2);
    v++;
    if (fd==stdout) {
      if ((v%20)==0) { if (getch()==27) break; }
     }
    else {
      if ((v&0xff)==0) { printf("."); if (bioskey(1)) break; }
     }
   }
  if (bioskey(1)) bioskey(0);
  printf("\n");
  return(0);
}


int main(int argc,char *argv[])
{
  if (argc<2) exit(1);
  if ((fs=fopen(argv[1],"rb"))==NULL) exit(1);
  fd=fopen("capt.log","wt");
  process(fd);
  fclose(fd);
  fclose(fs);
  return(0);
}

