; -----------------------------------------------------------
;
; -----------------------------------------------------------
;
	.386

; -----------------------------------------------------------
;
USENMI	equ	0
;
INT01	equ	01h*4
NMI	equ	02h*4
INT03	equ	03h*4
INT09	equ	09h*4
INT71	equ	71h*4

TIME	equ	6ch

FPGA	equ	178h
T5I	equ	151h
T5S	equ	153h

DGROUP          GROUP   _DATA
_TEXT		segment word public use16 'CODE'
		ASSUME  CS:_TEXT,DS:DGROUP,SS:DGROUP

MOVD	macro	SRC,DST
	mov	ax,word ptr SRC
	mov	dx,word ptr SRC+2
	mov	word ptr DST,ax
	mov	word ptr DST+2,dx
	endm

	org	0000h

; -----------------------------------------------------------
;
	jmp	start
	nop

old01	dd	0
old02	dd	0
old03	dd	0
old09	dd	0
istsr	dd	0

; -----------------------------------------------------------
;
	dd	44544332h		; 'DTC2'
;
new09	proc	far
	push	dx
	push	cx
	push	ax
	mov	dx,T5S
	xor	cx,cx
l09t1:	in	al,dx
	test	al,1
	loope	l09t1
	jcxz	end09
	mov	dx,FPGA
	in	al,dx
	inc	dx
	xchg	al,ah
	in	al,dx
	mov	dx,T5I
	out	dx,al
	mov	dx,T5S
	xor	cx,cx
l09t2:	in	al,dx
	test	al,1
	loope	l09t2
	jcxz	end09
	xchg	al,ah
	mov	dx,T5I
	out	dx,al
end09:	mov	al,20h
	out	20h,al
	out	0a0h,al
	IF	USENMI
	 in	al,61h
	 and	al,0f7h
	 out	61h,al
	 in	al,70h
	 and	al,7fh
	 out	70h,al
	 mov	dx,FPGA
	 mov	al,90h
	 out	dx,al
	ENDIF
	pop	ax
	pop	cx
	pop	dx
	iret
new09	endp

new02	proc	far
	IF	USENMI
	push	dx
	push	cx
	push	ax

	mov	dx,FPGA
	mov	al,80h
	out	dx,al
	mov	al,8dh
	out	70h,al
	in	al,61h
	or	al,0ch
	out	61h,al

	mov	dx,T5S
	xor	cx,cx
l02t1:	in	al,dx
	test	al,1
	loope	l02t1
	jcxz	end02
	mov	dx,FPGA
	in	al,dx
	inc	dx
	xchg	al,ah
	in	al,dx
	mov	dx,T5I
	out	dx,al
	mov	dx,T5S
	xor	cx,cx
l02t2:	in	al,dx
	test	al,1
	loope	l02t2
	jcxz	end02
	xchg	al,ah
	mov	dx,T5I
	out	dx,al

	in	al,61h
	and	al,0f7h
	out	61h,al
	mov	al,0dh
	out	70h,al
	mov	dx,FPGA
	mov	al,90h
	out	dx,al

end02:	pop	ax
	pop	cx
	pop	dx
	ENDIF
	iret
new02	endp

; -----------------------------------------------------------
;
start:
	push	ds
	push	es
	push	cs
	pop	ds
	push	0
	pop	es
	mov	byte ptr cs:istsr,0

; installation check (...)
	push	es
	mov	bx,es:[INT71]
	mov	ax,es:[INT71+2]
	sub	bx,4
	mov	es,ax
	mov	ax,es:[bx]
	mov	dx,es:[bx+2]
	pop	es
	cmp	ax,4332h
	jne	short reinst
	cmp	dx,4454h
	je	short react
;
reinst:	mov	byte ptr cs:istsr,1
	MOVD	es:[INT71],cs:[old09]
	MOVD	es:[NMI],cs:[old02]
;	mov	eax,dword ptr es:[INT01]
;	mov	cs:[old01],eax
;	mov	eax,dword ptr es:[INT03]
;	mov	cs:[old03],eax
	mov	dx,cs
	cli
	lea	ax,cs:new09
	mov	word ptr es:[INT71],ax
	mov	word ptr es:[INT71+2],dx
	IF	USENMI
	 lea	ax,cs:new02
	 mov	word ptr es:[NMI],ax
	 mov	word ptr es:[NMI+2],dx
	ENDIF
	sti
;
react:	cli
	in	al,0a1h
	and	al,0fdh
	out	0a1h,al
	in	al,70h
	or	al,80h
	out	70h,al
	sti
	mov	dx,FPGA
	mov	al,81h
	out	dx,al
	pop	es
	pop	ds

	test	byte ptr cs:istsr,1
	je	short notsr
	mov	ax,3100h
	lea	dx,cs:endcod
	add	dx,512
	shr	dx,4
	int	21h
fver:	jmp	short fver

notsr:	mov	ax,4c00h
	int	21h

endcod:	nop

_TEXT	ends

; -----------------------------------------------------------
;
_DATA           SEGMENT WORD PUBLIC USE16 'DATA'
_DATA           ENDS

; -----------------------------------------------------------
;
	end
